diff --git a/modules/LightRing_1-0/module.c b/modules/LightRing_1-0/module.c
index 94615e9..f67548a 100644
--- a/modules/LightRing_1-0/module.c
+++ b/modules/LightRing_1-0/module.c
@@ -63,8 +63,8 @@ SerialConfig moduleHalProgIfConfig = {
 SPIConfig moduleHalSpiLightConfig = {
   /* circular buffer mode        */ false,
   /* callback function pointer   */ NULL,
-  /* chip select line port       */ GPIOC,
-  /* chip select line pad number */ GPIOC_LIGHT_XLAT,
+  /* chip select line port       */ PAL_PORT(LINE_LIGHT_XLAT),
+  /* chip select line pad number */ PAL_PAD(LINE_LIGHT_XLAT),
   /* CR1                         */ SPI_CR1_BR_0 | SPI_CR1_BR_1,
   /* CR2                         */ SPI_CR2_RXDMAEN | SPI_CR2_TXDMAEN,
 };
@@ -72,8 +72,8 @@ SPIConfig moduleHalSpiLightConfig = {
 SPIConfig moduleHalSpiWlConfig = {
   /* circular buffer mode        */ false,
   /* callback function pointer   */ NULL,
-  /* chip select line port       */ GPIOB,
-  /* chip select line pad number */ GPIOB_WL_SS_N,
+  /* chip select line port       */ PAL_PORT(LINE_WL_SS_N),
+  /* chip select line pad number */ PAL_PAD(LINE_WL_SS_N),
   /* CR1                         */ SPI_CR1_BR_0,
   /* CR2                         */ SPI_CR2_RXDMAEN | SPI_CR2_TXDMAEN,
 };
@@ -89,8 +89,7 @@ SPIConfig moduleHalSpiWlConfig = {
  * @brief   LIGHT_BANK output signal GPIO.
  */
 static apalGpio_t _gpioLightBlank = {
-  /* port */ GPIOA,
-  /* pad  */ GPIOA_LIGHT_BLANK,
+  /* line */ LINE_LIGHT_BLANK,
 };
 ROMCONST apalControlGpio_t moduleGpioLightBlank = {
   /* GPIO */ &_gpioLightBlank,
@@ -105,8 +104,7 @@ ROMCONST apalControlGpio_t moduleGpioLightBlank = {
  * @brief   LASER_EN output signal GPIO.
  */
 static apalGpio_t _gpioLaserEn = {
-  /* port */ GPIOB,
-  /* pad  */ GPIOB_LASER_EN,
+  /* line */ LINE_LASER_EN,
 };
 ROMCONST apalControlGpio_t moduleGpioLaserEn = {
   /* GPIO */ &_gpioLaserEn,
@@ -121,8 +119,7 @@ ROMCONST apalControlGpio_t moduleGpioLaserEn = {
  * @brief   LASER_OC input signal GPIO.
  */
 static apalGpio_t _gpioLaserOc = {
-  /* port */ GPIOB,
-  /* pad  */ GPIOB_LASER_OC_N,
+  /* line */ LINE_LASER_OC_N,
 };
 ROMCONST apalControlGpio_t moduleGpioLaserOc = {
   /* GPIO */ &_gpioLaserOc,
@@ -137,8 +134,7 @@ ROMCONST apalControlGpio_t moduleGpioLaserOc = {
  * @brief   SYS_UART_DN bidirectional signal GPIO.
  */
 static apalGpio_t _gpioSysUartDn = {
-  /* port */ GPIOB,
-  /* pad  */ GPIOB_SYS_UART_DN,
+  /* line */ LINE_SYS_UART_DN,
 };
 ROMCONST apalControlGpio_t moduleGpioSysUartDn = {
   /* GPIO */ &_gpioSysUartDn,
@@ -153,8 +149,7 @@ ROMCONST apalControlGpio_t moduleGpioSysUartDn = {
  * @brief   WL_GDO2 input signal GPIO.
  */
 static apalGpio_t _gpioWlGdo2 = {
-  /* port */ GPIOB,
-  /* pad  */ GPIOB_WL_GDO2,
+  /* line */ LINE_WL_GDO2,
 };
 ROMCONST apalControlGpio_t moduleGpioWlGdo2 = {
   /* GPIO */ &_gpioWlGdo2,
@@ -169,8 +164,7 @@ ROMCONST apalControlGpio_t moduleGpioWlGdo2 = {
  * @brief   WL_GDO0 input signal GPIO.
  */
 static apalGpio_t _gpioWlGdo0= {
-  /* port */ GPIOB,
-  /* pad  */ GPIOB_WL_GDO0,
+  /* line */ LINE_WL_GDO0,
 };
 ROMCONST apalControlGpio_t moduleGpioWlGdo0 = {
   /* GPIO */ &_gpioWlGdo0,
@@ -182,27 +176,10 @@ ROMCONST apalControlGpio_t moduleGpioWlGdo0 = {
 };
 
 /**
- * @brief   LIGHT_XLAT output signal GPIO.
- */
-static apalGpio_t _gpioLightXlat = {
-  /* port */ GPIOC,
-  /* pad  */ GPIOC_LIGHT_XLAT,
-};
-ROMCONST apalControlGpio_t moduleGpioLightXlat = {
-  /* GPIO */ &_gpioLightXlat,
-  /* meta */ {
-    /* direction      */ APAL_GPIO_DIRECTION_OUTPUT,
-    /* active state   */ TLC5947_LLD_XLAT_ACTIVE_STATE,
-    /* interrupt edge */ APAL_GPIO_EDGE_NONE,
-  },
-};
-
-/**
  * @brief   SYS_PD bidirectional signal GPIO.
  */
 static apalGpio_t _gpioSysPd = {
-  /* port */ GPIOC,
-  /* pad  */ GPIOC_SYS_PD_N,
+  /* line */ LINE_SYS_PD_N,
 };
 ROMCONST apalControlGpio_t moduleGpioSysPd = {
   /* GPIO */ &_gpioSysPd,
@@ -217,8 +194,7 @@ ROMCONST apalControlGpio_t moduleGpioSysPd = {
  * @brief   SYS_SYNC bidirectional signal GPIO.
  */
 static apalGpio_t _gpioSysSync = {
-  /* port */ GPIOD,
-  /* pad  */ GPIOD_SYS_INT_N,
+  /* line */ LINE_SYS_INT_N,
 };
 ROMCONST apalControlGpio_t moduleGpioSysSync = {
   /* GPIO */ &_gpioSysSync,
@@ -268,7 +244,7 @@ AT24C01BDriver moduleLldEeprom = {
 TLC5947Driver moduleLldLedPwm = {
   /* SPI driver         */ &MODULE_HAL_SPI_LIGHT,
   /* BLANK signal GPIO  */ &moduleGpioLightBlank,
-  /* XLAT signal GPIO   */ &moduleGpioLightXlat,
+  /* XLAT signal GPIO   */ NULL,
 };
 
 TPS20xxBDriver moduleLldPowerSwitchLaser = {
diff --git a/modules/LightRing_1-0/module.h b/modules/LightRing_1-0/module.h
index a07a0d1..fbcbb64 100644
--- a/modules/LightRing_1-0/module.h
+++ b/modules/LightRing_1-0/module.h
@@ -140,11 +140,6 @@ extern ROMCONST apalControlGpio_t moduleGpioWlGdo2;
 extern ROMCONST apalControlGpio_t moduleGpioWlGdo0;
 
 /**
- * @brief   LIGHT_XLAT output signal GPIO.
- */
-extern ROMCONST apalControlGpio_t moduleGpioLightXlat;
-
-/**
  * @brief   SYS_PD bidirectional signal GPIO.
  */
 extern ROMCONST apalControlGpio_t moduleGpioSysPd;
@@ -166,32 +161,32 @@ extern ROMCONST apalControlGpio_t moduleGpioSysSync;
 /**
  * @brief   Event flag to be set on a LASER_OC interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_LASEROC          AOS_IOEVENT_FLAG(GPIOB_LASER_OC_N)
+#define MODULE_OS_IOEVENTFLAGS_LASEROC          AOS_IOEVENT_FLAG(PAL_PAD(LINE_LASER_OC_N))
 
 /**
  * @brief   Event flag to be set on a SYS_UART_DN interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_SYSUARTDN        AOS_IOEVENT_FLAG(GPIOB_SYS_UART_DN)
+#define MODULE_OS_IOEVENTFLAGS_SYSUARTDN        AOS_IOEVENT_FLAG(PAL_PAD(LINE_SYS_UART_DN))
 
 /**
  * @brief   Event flag to be set on a WL_GDO2 interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_WLGDO2           AOS_IOEVENT_FLAG(GPIOB_WL_GDO2)
+#define MODULE_OS_IOEVENTFLAGS_WLGDO2           AOS_IOEVENT_FLAG(PAL_PAD(LINE_WL_GDO2))
 
 /**
  * @brief   Event flag to be set on a WL_GDO0 interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_WLGDO0           AOS_IOEVENT_FLAG(GPIOB_WL_GDO0)
+#define MODULE_OS_IOEVENTFLAGS_WLGDO0           AOS_IOEVENT_FLAG(PAL_PAD(LINE_WL_GDO0))
 
 /**
  * @brief   Event flag to be set on a SYS_PD interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_SYSPD            AOS_IOEVENT_FLAG(GPIOC_SYS_PD_N)
+#define MODULE_OS_IOEVENTFLAGS_SYSPD            AOS_IOEVENT_FLAG(PAL_PAD(LINE_SYS_PD_N))
 
 /**
  * @brief   Event flag to be set on a SYS_SYNC interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_SYSSYNC          AOS_IOEVENT_FLAG(GPIOD_SYS_INT_N)
+#define MODULE_OS_IOEVENTFLAGS_SYSSYNC          AOS_IOEVENT_FLAG(PAL_PAD(LINE_SYS_INT_N))
 
 #if (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
 /**
@@ -206,14 +201,14 @@ extern ROMCONST char* moduleShellPrompt;
  */
 #define MODULE_INIT_INTERRUPTS() {                                            \
   /* LASER_OC */                                                              \
-  palSetPadCallback(moduleGpioLaserOc.gpio->port, moduleGpioLaserOc.gpio->pad, _intCallback, &moduleGpioLaserOc.gpio->pad); \
-  palEnablePadEvent(moduleGpioLaserOc.gpio->port, moduleGpioLaserOc.gpio->pad, APAL2CH_EDGE(moduleGpioLaserOc.meta.edge));  \
+  palSetLineCallback(moduleGpioLaserOc.gpio->line, aosSysGetStdIntCallback(), &moduleGpioLaserOc.gpio->line); \
+  palEnableLineEvent(moduleGpioLaserOc.gpio->line, APAL2CH_EDGE(moduleGpioLaserOc.meta.edge));                \
   /* WL_GDO2 */                                                               \
-  palSetPadCallback(moduleGpioWlGdo2.gpio->port, moduleGpioWlGdo2.gpio->pad, _intCallback, &moduleGpioWlGdo2.gpio->pad);  \
-  palEnablePadEvent(moduleGpioWlGdo2.gpio->port, moduleGpioWlGdo2.gpio->pad, APAL2CH_EDGE(moduleGpioWlGdo2.meta.edge));   \
+  palSetLineCallback(moduleGpioWlGdo2.gpio->line, aosSysGetStdIntCallback(), &moduleGpioWlGdo2.gpio->line); \
+  palEnableLineEvent(moduleGpioWlGdo2.gpio->line, APAL2CH_EDGE(moduleGpioWlGdo2.meta.edge));                \
   /* WL_GDO0 */                                                               \
-  palSetPadCallback(moduleGpioWlGdo0.gpio->port, moduleGpioWlGdo0.gpio->pad, _intCallback, &moduleGpioWlGdo0.gpio->pad);  \
-  /*palEnablePadEvent(moduleGpioWlGdo0.gpio->port, moduleGpioWlGdo0.gpio->pad, APAL2CH_EDGE(moduleGpioWlGdo0.meta.edge)); // this is broken for some reason*/   \
+  palSetLineCallback(moduleGpioWlGdo0.gpio->line, aosSysGetStdIntCallback(), &moduleGpioWlGdo0.gpio->line); \
+  palEnableLineEvent(moduleGpioWlGdo0.gpio->line, APAL2CH_EDGE(moduleGpioWlGdo0.meta.edge));                \
 }
 
 /**
diff --git a/modules/LightRing_1-2/alldconf.h b/modules/LightRing_1-2/alldconf.h
index e48b914..136aaa7 100644
--- a/modules/LightRing_1-2/alldconf.h
+++ b/modules/LightRing_1-2/alldconf.h
@@ -33,7 +33,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 #define _AMIRO_LLD_CFG_
 #define AMIRO_LLD_CFG_VERSION_MAJOR             1
-#define AMIRO_LLD_CFG_VERSION_MINOR             0
+#define AMIRO_LLD_CFG_VERSION_MINOR             1
 
 /**
  * @brief   Width of the apalTime_t data type.
diff --git a/modules/LightRing_1-2/module.c b/modules/LightRing_1-2/module.c
index 3e61956..f0f3dbc 100644
--- a/modules/LightRing_1-2/module.c
+++ b/modules/LightRing_1-2/module.c
@@ -63,8 +63,8 @@ SerialConfig moduleHalProgIfConfig = {
 SPIConfig moduleHalSpiLightConfig = {
   /* circular buffer mode        */ false,
   /* callback function pointer   */ NULL,
-  /* chip select line port       */ GPIOC,
-  /* chip select line pad number */ GPIOC_LIGHT_XLAT,
+  /* chip select line port       */ PAL_PORT(LINE_LIGHT_XLAT),
+  /* chip select line pad number */ PAL_PAD(LINE_LIGHT_XLAT),
   /* CR1                         */ SPI_CR1_BR_0 | SPI_CR1_BR_1,
   /* CR2                         */ SPI_CR2_RXDMAEN | SPI_CR2_TXDMAEN,
 };
@@ -81,8 +81,7 @@ SPIConfig moduleHalSpiLightConfig = {
  * @brief   LIGHT_BANK output signal GPIO.
  */
 static apalGpio_t _gpioLightBlank = {
-  /* port */ GPIOA,
-  /* pad  */ GPIOA_LIGHT_BLANK,
+  /* line */ LINE_LIGHT_BLANK,
 };
 ROMCONST apalControlGpio_t moduleGpioLightBlank = {
   /* GPIO */ &_gpioLightBlank,
@@ -97,8 +96,7 @@ ROMCONST apalControlGpio_t moduleGpioLightBlank = {
  * @brief   RS232_R_EN_N output signal GPIO.
  */
 static apalGpio_t _gpioRs232En = {
-  /* port */ GPIOA,
-  /* pad  */ GPIOA_RS232_R_EN_N,
+  /* line */ LINE_RS232_R_EN_N,
 };
 ROMCONST apalControlGpio_t moduleGpioRs232En = {
   /* GPIO */ &_gpioRs232En,
@@ -113,8 +111,7 @@ ROMCONST apalControlGpio_t moduleGpioRs232En = {
  * @brief   SW_V33_EN output signal GPIO.
  */
 static apalGpio_t _gpioSwV33En = {
-  /* port */ GPIOB,
-  /* pad  */ GPIOB_SW_V33_EN,
+  /* line */ LINE_SW_V33_EN,
 };
 ROMCONST apalControlGpio_t moduleGpioSwV33En = {
   /* GPIO */ &_gpioSwV33En,
@@ -129,8 +126,7 @@ ROMCONST apalControlGpio_t moduleGpioSwV33En = {
  * @brief   SW_V42_EN output signal GPIO.
  */
 static apalGpio_t _gpioSwV42En = {
-  /* port */ GPIOB,
-  /* pad  */ GPIOB_SW_V42_EN,
+  /* line */ LINE_SW_V42_EN,
 };
 ROMCONST apalControlGpio_t moduleGpioSwV42En = {
   /* GPIO */ &_gpioSwV42En,
@@ -145,8 +141,7 @@ ROMCONST apalControlGpio_t moduleGpioSwV42En = {
  * @brief   SW_V50_EN output signal GPIO.
  */
 static apalGpio_t _gpioSwV50En = {
-  /* port */ GPIOB,
-  /* pad  */ GPIOB_SW_V50_EN,
+  /* line */ LINE_SW_V50_EN,
 };
 ROMCONST apalControlGpio_t moduleGpioSwV50En = {
   /* GPIO */ &_gpioSwV50En,
@@ -161,8 +156,7 @@ ROMCONST apalControlGpio_t moduleGpioSwV50En = {
  * @brief   IO_3 breakout signal GPIO.
  */
 static apalGpio_t _gpioBreakoutIo3 = {
-  /* port */ GPIOB,
-  /* pad  */ GPIOB_IO_3,
+  /* line */ LINE_IO_3,
 };
 apalControlGpio_t moduleGpioBreakoutIo3 = {
   /* GPIO */ &_gpioBreakoutIo3,
@@ -177,8 +171,7 @@ apalControlGpio_t moduleGpioBreakoutIo3 = {
  * @brief   IO_5 breakout signal GPIO.
  */
 static apalGpio_t _gpioBreakoutIo5 = {
-  /* port */ GPIOB,
-  /* pad  */ GPIOB_IO_5,
+  /* line */ LINE_IO_5,
 };
 apalControlGpio_t moduleGpioBreakoutIo5 = {
   /* GPIO */ &_gpioBreakoutIo5,
@@ -193,8 +186,7 @@ apalControlGpio_t moduleGpioBreakoutIo5 = {
  * @brief   IO_6 breakout signal GPIO.
  */
 static apalGpio_t _gpioBreakoutIo6 = {
-  /* port */ GPIOB,
-  /* pad  */ GPIOB_IO_6,
+  /* line */ LINE_IO_6,
 };
 apalControlGpio_t moduleGpioBreakoutIo6 = {
   /* GPIO */ &_gpioBreakoutIo6,
@@ -209,8 +201,7 @@ apalControlGpio_t moduleGpioBreakoutIo6 = {
  * @brief   SYS_UART_DN bidirectional signal GPIO.
  */
 static apalGpio_t _gpioSysUartDn = {
-  /* port */ GPIOB,
-  /* pad  */ GPIOB_SYS_UART_DN,
+  /* line */ LINE_SYS_UART_DN,
 };
 ROMCONST apalControlGpio_t moduleGpioSysUartDn = {
   /* GPIO */ &_gpioSysUartDn,
@@ -225,8 +216,7 @@ ROMCONST apalControlGpio_t moduleGpioSysUartDn = {
  * @brief   IO_7 breakout signal GPIO.
  */
 static apalGpio_t _gpioBreakoutIo7 = {
-  /* port */ GPIOB,
-  /* pad  */ GPIOB_IO_7,
+  /* line */ LINE_IO_7,
 };
 apalControlGpio_t moduleGpioBreakoutIo7 = {
   /* GPIO */ &_gpioBreakoutIo7,
@@ -241,8 +231,7 @@ apalControlGpio_t moduleGpioBreakoutIo7 = {
  * @brief   IO_8 breakout signal GPIO.
  */
 static apalGpio_t _gpioBreakoutIo8 = {
-  /* port */ GPIOB,
-  /* pad  */ GPIOB_IO_8,
+  /* line */ LINE_IO_8,
 };
 apalControlGpio_t moduleGpioBreakoutIo8 = {
   /* GPIO */ &_gpioBreakoutIo8,
@@ -257,8 +246,7 @@ apalControlGpio_t moduleGpioBreakoutIo8 = {
  * @brief   IO_4 breakout signal GPIO.
  */
 static apalGpio_t _gpioBreakoutIo4 = {
-  /* port */ GPIOC,
-  /* pad  */ GPIOC_IO_4,
+  /* line */ LINE_IO_4,
 };
 apalControlGpio_t moduleGpioBreakoutIo4 = {
   /* GPIO */ &_gpioBreakoutIo4,
@@ -273,8 +261,7 @@ apalControlGpio_t moduleGpioBreakoutIo4 = {
  * @brief   IO_1 breakout signal GPIO.
  */
 static apalGpio_t _gpioBreakoutIo1 = {
-  /* port */ GPIOC,
-  /* pad  */ GPIOC_IO_1,
+  /* line */ LINE_IO_1,
 };
 apalControlGpio_t moduleGpioBreakoutIo1 = {
   /* GPIO */ &_gpioBreakoutIo1,
@@ -289,8 +276,7 @@ apalControlGpio_t moduleGpioBreakoutIo1 = {
  * @brief   IO_2 breakout signal GPIO.
  */
 static apalGpio_t _gpioBreakoutIo2 = {
-  /* port */ GPIOC,
-  /* pad  */ GPIOC_IO_2,
+  /* line */ LINE_IO_2,
 };
 apalControlGpio_t moduleGpioBreakoutIo2 = {
   /* GPIO */ &_gpioBreakoutIo2,
@@ -305,8 +291,7 @@ apalControlGpio_t moduleGpioBreakoutIo2 = {
  * @brief   LED output signal GPIO.
  */
 static apalGpio_t _gpioLed = {
-  /* port */ GPIOC,
-  /* pad  */ GPIOC_LED,
+  /* line */ LINE_LED,
 };
 ROMCONST apalControlGpio_t moduleGpioLed = {
   /* GPIO */ &_gpioLed,
@@ -318,27 +303,10 @@ ROMCONST apalControlGpio_t moduleGpioLed = {
 };
 
 /**
- * @brief   LIGHT_XLAT output signal GPIO.
- */
-static apalGpio_t _gpioLightXlat = {
-  /* port */ GPIOC,
-  /* pad  */ GPIOC_LIGHT_XLAT,
-};
-ROMCONST apalControlGpio_t moduleGpioLightXlat = {
-  /* GPIO */ &_gpioLightXlat,
-  /* meta */ {
-    /* direction      */ APAL_GPIO_DIRECTION_OUTPUT,
-    /* active state   */ TLC5947_LLD_XLAT_ACTIVE_STATE,
-    /* interrupt edge */ APAL_GPIO_EDGE_NONE,
-  },
-};
-
-/**
  * @brief   SW_V18_EN output signal GPIO.
  */
 static apalGpio_t _gpioSwV18En = {
-  /* port */ GPIOC,
-  /* pad  */ GPIOC_SW_V18_EN,
+  /* line */ LINE_SW_V18_EN,
 };
 ROMCONST apalControlGpio_t moduleGpioSwV18En = {
   /* GPIO */ &_gpioSwV18En,
@@ -353,8 +321,7 @@ ROMCONST apalControlGpio_t moduleGpioSwV18En = {
  * @brief   SW_VSYS_EN output signal GPIO.
  */
 static apalGpio_t _gpioSwVsysEn = {
-  /* port */ GPIOC,
-  /* pad  */ GPIOC_SW_VSYS_EN,
+  /* line */ LINE_SW_VSYS_EN,
 };
 ROMCONST apalControlGpio_t moduleGpioSwVsysEn = {
   /* GPIO */ &_gpioSwVsysEn,
@@ -369,8 +336,7 @@ ROMCONST apalControlGpio_t moduleGpioSwVsysEn = {
  * @brief   SYS_UART_UP bidirectional signal GPIO.
  */
 static apalGpio_t _gpioSysUartUp = {
-  /* port */ GPIOC,
-  /* pad  */ GPIOC_SYS_UART_UP,
+  /* line */ LINE_SYS_UART_UP,
 };
 ROMCONST apalControlGpio_t moduleGpioSysUartUp = {
   /* GPIO */ &_gpioSysUartUp,
@@ -385,8 +351,7 @@ ROMCONST apalControlGpio_t moduleGpioSysUartUp = {
  * @brief   SYS_PD bidirectional signal GPIO.
  */
 static apalGpio_t _gpioSysPd = {
-  /* port */ GPIOC,
-  /* pad  */ GPIOC_SYS_PD_N,
+  /* line */ LINE_SYS_PD_N,
 };
 ROMCONST apalControlGpio_t moduleGpioSysPd = {
   /* GPIO */ &_gpioSysPd,
@@ -401,8 +366,7 @@ ROMCONST apalControlGpio_t moduleGpioSysPd = {
  * @brief   SYS_SYNC bidirectional signal GPIO.
  */
 static apalGpio_t _gpioSysSync = {
-  /* port */ GPIOD,
-  /* pad  */ GPIOD_SYS_INT_N,
+  /* line */ LINE_SYS_INT_N,
 };
 ROMCONST apalControlGpio_t moduleGpioSysSync = {
   /* GPIO */ &_gpioSysSync,
@@ -483,7 +447,7 @@ MIC9404xDriver moduleLldPowerSwitchVsys = {
 TLC5947Driver moduleLldLedPwm = {
   /* SPI driver         */ &MODULE_HAL_SPI_LIGHT,
   /* BLANK signal GPIO  */ &moduleGpioLightBlank,
-  /* XLAT signal GPIO   */ &moduleGpioLightXlat,
+  /* XLAT signal GPIO   */ NULL,
 };
 
 /** @} */
diff --git a/modules/LightRing_1-2/module.h b/modules/LightRing_1-2/module.h
index 9e481a9..f239269 100644
--- a/modules/LightRing_1-2/module.h
+++ b/modules/LightRing_1-2/module.h
@@ -185,11 +185,6 @@ extern apalControlGpio_t moduleGpioBreakoutIo2;
 extern ROMCONST apalControlGpio_t moduleGpioLed;
 
 /**
- * @brief   LIGHT_XLAT output signal GPIO.
- */
-extern ROMCONST apalControlGpio_t moduleGpioLightXlat;
-
-/**
  * @brief   SW_V18_EN output signal GPIO.
  */
 extern ROMCONST apalControlGpio_t moduleGpioSwV18En;
@@ -226,57 +221,57 @@ extern ROMCONST apalControlGpio_t moduleGpioSysSync;
 /**
  * @brief   Event flag to be set on a IO_4 (breakout) interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_BREAKOUTIO4      AOS_IOEVENT_FLAG(GPIOC_IO_4)
+#define MODULE_OS_IOEVENTFLAGS_BREAKOUTIO4      AOS_IOEVENT_FLAG(PAL_PAD(LINE_IO_4))
 
 /**
  * @brief   Event flag to be set on a IO_1 (breakout) interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_BREAKOUTIO1      AOS_IOEVENT_FLAG(GPIOC_IO_1)
+#define MODULE_OS_IOEVENTFLAGS_BREAKOUTIO1      AOS_IOEVENT_FLAG(PAL_PAD(LINE_IO_1))
 
 /**
  * @brief   Event flag to be set on a SYS_SYNC interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_SYSSYNC          AOS_IOEVENT_FLAG(GPIOD_SYS_INT_N)
+#define MODULE_OS_IOEVENTFLAGS_SYSSYNC          AOS_IOEVENT_FLAG(PAL_PAD(LINE_SYS_INT_N))
 
 /**
  * @brief   Event flag to be set on a IO_3 (breakout) interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_BREAKOUTIO3      AOS_IOEVENT_FLAG(GPIOB_IO_3)
+#define MODULE_OS_IOEVENTFLAGS_BREAKOUTIO3      AOS_IOEVENT_FLAG(PAL_PAD(LINE_IO_3))
 
 /**
  * @brief   Event flag to be set on a IO_5 (breakout) interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_BREAKOUTIO5      AOS_IOEVENT_FLAG(GPIOB_IO_5)
+#define MODULE_OS_IOEVENTFLAGS_BREAKOUTIO5      AOS_IOEVENT_FLAG(PAL_PAD(LINE_IO_5))
 
 /**
  * @brief   Event flag to be set on a IO_6 (breakout) interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_BREAKOUTIO6      AOS_IOEVENT_FLAG(GPIOB_IO_6)
+#define MODULE_OS_IOEVENTFLAGS_BREAKOUTIO6      AOS_IOEVENT_FLAG(PAL_PAD(LINE_IO_6))
 
 /**
  * @brief   Event flag to be set on a SYS_UART_DN interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_SYSUARTDN        AOS_IOEVENT_FLAG(GPIOB_SYS_UART_DN)
+#define MODULE_OS_IOEVENTFLAGS_SYSUARTDN        AOS_IOEVENT_FLAG(PAL_PAD(LINE_SYS_UART_DN))
 
 /**
  * @brief   Event flag to be set on a SYS_UART_UP interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_SYSUARTUP        AOS_IOEVENT_FLAG(GPIOC_SYS_UART_UP)
+#define MODULE_OS_IOEVENTFLAGS_SYSUARTUP        AOS_IOEVENT_FLAG(PAL_PAD(LINE_SYS_UART_UP))
 
 /**
  * @brief   Event flag to be set on a IO_7 (breakout) interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_BREAKOUTIO7      AOS_IOEVENT_FLAG(GPIOB_IO_7)
+#define MODULE_OS_IOEVENTFLAGS_BREAKOUTIO7      AOS_IOEVENT_FLAG(PAL_PAD(LINE_IO_7))
 
 /**
  * @brief   Event flag to be set on a IO_8 (breakout) interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_BREAKOUTIO8      AOS_IOEVENT_FLAG(GPIOB_IO_8)
+#define MODULE_OS_IOEVENTFLAGS_BREAKOUTIO8      AOS_IOEVENT_FLAG(PAL_PAD(LINE_IO_8))
 
 /**
  * @brief   Event flag to be set on a SYS_PD interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_SYSPD            AOS_IOEVENT_FLAG(GPIOC_SYS_PD_N)
+#define MODULE_OS_IOEVENTFLAGS_SYSPD            AOS_IOEVENT_FLAG(PAL_PAD(LINE_SYS_PD_N))
 
 #if (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
 /**
diff --git a/modules/NUCLEO-F103RB/alldconf.h b/modules/NUCLEO-F103RB/alldconf.h
index 20b7bba..606722c 100644
--- a/modules/NUCLEO-F103RB/alldconf.h
+++ b/modules/NUCLEO-F103RB/alldconf.h
@@ -33,7 +33,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 #define _AMIRO_LLD_CFG_
 #define AMIRO_LLD_CFG_VERSION_MAJOR             1
-#define AMIRO_LLD_CFG_VERSION_MINOR             0
+#define AMIRO_LLD_CFG_VERSION_MINOR             1
 
 /**
  * @brief   Width of the apalTime_t data type.
@@ -43,7 +43,11 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 #define AMIROLLD_CFG_TIME_SIZE                  32
 
-#define AMIROLLD_CFG_DW1000                     1
+/**
+ * @brief   Enable flag for the DW1000 UWB transmitter.
+ * @note    Uncomment this if the device is attached.
+ */
+//#define AMIROLLD_CFG_DW1000                     1
 
 #endif /* ALLDCONF_H */
 
diff --git a/modules/NUCLEO-F103RB/board.h b/modules/NUCLEO-F103RB/board.h
index b5ed689..9b4c995 100644
--- a/modules/NUCLEO-F103RB/board.h
+++ b/modules/NUCLEO-F103RB/board.h
@@ -63,8 +63,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #define GPIOA_USART2_RX             3U
 #define GPIOA_ARD_A2                4U
 #define GPIOA_ADC1_IN4              4U
-#define GPIOA_LED_GREEN             5U
 #define GPIOA_ARD_D13               5U
+#define GPIOA_LED_GREEN             5U
 #define GPIOA_ARD_D12               6U
 #define GPIOA_ARD_D11               7U
 #define GPIOA_ARD_D7                8U
@@ -80,8 +80,8 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #define GPIOB_ADC1_IN8              0U
 #define GPIOB_PIN1                  1U
 #define GPIOB_PIN2                  2U
-#define GPIOB_SWO                   3U
 #define GPIOB_ARD_D3                3U
+#define GPIOB_SWO                   3U
 #define GPIOB_ARD_D5                4U
 #define GPIOB_ARD_D4                5U
 #define GPIOB_ARD_D10               6U
@@ -166,6 +166,52 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #define GPIOF_PIN13                 13U
 #define GPIOF_PIN14                 14U
 #define GPIOF_PIN15                 15U
+
+/*
+ * IO lines assignments.
+ */
+#define LINE_ARD_A0                 PAL_LINE(GPIOA, GPIOA_ARD_A0)
+#define LINE_ADC1_IN0               PAL_LINE(GPIOA, GPIOA_ADC1_IN0)
+#define LINE_ARD_A1                 PAL_LINE(GPIOA, GPIOA_ARD_A1)
+#define LINE_ADC1_IN1               PAL_LINE(GPIOA, GPIOA_ADC1_IN1)
+#define LINE_ARD_D1                 PAL_LINE(GPIOA, GPIOA_ARD_D1)
+#define LINE_USART2_TX              PAL_LINE(GPIOA, GPIOA_USART2_TX)
+#define LINE_ARD_D0                 PAL_LINE(GPIOA, GPIOA_ARD_D0)
+#define LINE_USART2_RX              PAL_LINE(GPIOA, GPIOA_USART2_RX)
+#define LINE_ARD_A2                 PAL_LINE(GPIOA, GPIOA_ARD_A2)
+#define LINE_ADC1_IN4               PAL_LINE(GPIOA, GPIOA_ADC1_IN4)
+#define LINE_ARD_D13                PAL_LINE(GPIOA, GPIOA_ARD_D13)
+#define LINE_LED_GREEN              PAL_LINE(GPIOA, GPIOA_LED_GREEN)
+#define LINE_ARD_D12                PAL_LINE(GPIOA, GPIOA_ARD_D12)
+#define LINE_ARD_D11                PAL_LINE(GPIOA, GPIOA_ARD_D11)
+#define LINE_ARD_D7                 PAL_LINE(GPIOA, GPIOA_ARD_D7)
+#define LINE_ARD_D8                 PAL_LINE(GPIOA, GPIOA_ARD_D8)
+#define LINE_ARD_D2                 PAL_LINE(GPIOA, GPIOA_ARD_D2)
+#define LINE_SWDIO                  PAL_LINE(GPIOA, GPIOA_SWDIO)
+#define LINE_SWCLK                  PAL_LINE(GPIOA, GPIOA_SWCLK)
+
+#define LINE_ARD_A3                 PAL_LINE(GPIOB, GPIOB_ARD_A3)
+#define LINE_ADC1_IN8               PAL_LINE(GPIOB, GPIOB_ADC1_IN8)
+#define LINE_ARD_D3                 PAL_LINE(GPIOB, GPIOB_ARD_D3)
+#define LINE_SWO                    PAL_LINE(GPIOB, GPIOB_SWO)
+#define LINE_ARD_D5                 PAL_LINE(GPIOB, GPIOB_ARD_D5)
+#define LINE_ARD_D4                 PAL_LINE(GPIOB, GPIOB_ARD_D4)
+#define LINE_ARD_D10                PAL_LINE(GPIOB, GPIOB_ARD_D10)
+#define LINE_ARD_D15                PAL_LINE(GPIOB, GPIOB_ARD_D15)
+#define LINE_ARD_D14                PAL_LINE(GPIOB, GPIOB_ARD_D14)
+#define LINE_ARD_D6                 PAL_LINE(GPIOB, GPIOB_ARD_D6)
+
+#define LINE_ARD_A5                 PAL_LINE(GPIOC, GPIOC_ARD_A5)
+#define LINE_ADC1_IN11              PAL_LINE(GPIOC, GPIOC_ADC1_IN11)
+#define LINE_ARD_A4                 PAL_LINE(GPIOC, GPIOC_ARD_A4)
+#define LINE_ADC1_IN10              PAL_LINE(GPIOC, GPIOC_ADC1_IN10)
+#define LINE_ARD_D9                 PAL_LINE(GPIOC, GPIOC_ARD_D9)
+#define LINE_BUTTON                 PAL_LINE(GPIOC, GPIOC_BUTTON)
+
+#define LINE_OSC_IN                 PAL_LINE(GPIOD, GPIOH_OSC_IN)
+#define LINE_OSC_OUT                PAL_LINE(GPIOD, GPIOH_OSC_OUT)
+
+
 /*
  * I/O ports initial setup, this configuration is established soon after reset
  * in the initialization code.
diff --git a/modules/NUCLEO-F103RB/module.c b/modules/NUCLEO-F103RB/module.c
index 54c4129..11fcafd 100644
--- a/modules/NUCLEO-F103RB/module.c
+++ b/modules/NUCLEO-F103RB/module.c
@@ -85,8 +85,7 @@ SPIConfig moduleHalSpiUwbLsConfig = {
  * @brief   LED output signal GPIO.
  */
 static apalGpio_t _gpioLed = {
-  /* port */ GPIOA,
-  /* pad  */ GPIOA_LED_GREEN,
+  /* line */ PAL_LINE(GPIOA, GPIOA_LED_GREEN),
 };
 ROMCONST apalControlGpio_t moduleGpioLed = {
   /* GPIO */ &_gpioLed,
@@ -103,8 +102,7 @@ ROMCONST apalControlGpio_t moduleGpioLed = {
  * @brief   DW1000 reset output signal GPIO.
  */
 static apalGpio_t _gpioDw1000Reset = {
-  /* port */ GPIOA,
-  /* pad  */ GPIOA_ARD_A0,   // PIN0
+  /* line */ PAL_LINE(GPIOA, GPIOA_ARD_A0),
 };
 ROMCONST apalControlGpio_t moduleGpioDw1000Reset = {
   /* GPIO */ &_gpioDw1000Reset,
@@ -120,8 +118,7 @@ ROMCONST apalControlGpio_t moduleGpioDw1000Reset = {
  * @brief   DW1000 interrrupt input signal GPIO.
  */
 static apalGpio_t _gpioDw1000Irqn = {
-  /* port */ GPIOB,
-  /* pad  */ GPIOB_ARD_D6,  // GPIOB_PIN10
+  /* line */ PAL_LINE(GPIOB, GPIOB_ARD_D6),
 };
 ROMCONST apalControlGpio_t moduleGpioDw1000Irqn = {
   /* GPIO */ &_gpioDw1000Irqn,
@@ -137,8 +134,7 @@ ROMCONST apalControlGpio_t moduleGpioDw1000Irqn = {
  * @brief   DW1000 SPI chip select output signal GPIO.
  */
 static apalGpio_t _gpioSpiChipSelect = {
-  /* port */ GPIOB,
-  /* pad  */ GPIOB_PIN12,  // GPIOB_PIN10
+  /* line */ PAL_LINE(GPIOB, GPIOB_PIN12),
 };
 ROMCONST apalControlGpio_t moduleGpioSpiChipSelect = {
   /* GPIO */ &_gpioSpiChipSelect,
@@ -155,8 +151,7 @@ ROMCONST apalControlGpio_t moduleGpioSpiChipSelect = {
  * @brief   User button input signal GPIO.
  */
 static apalGpio_t _gpioUserButton = {
-  /* port */ GPIOC,
-  /* pad  */ GPIOC_BUTTON,
+  /* line */ PAL_LINE(GPIOC, GPIOC_BUTTON),
 };
 ROMCONST apalControlGpio_t moduleGpioUserButton = {
   /* GPIO */ &_gpioUserButton,
@@ -204,7 +199,7 @@ void dw1000_spi_init(void){
   palSetPadMode(GPIOB, GPIOB_PIN13, PAL_MODE_STM32_ALTERNATE_PUSHPULL);
   palSetPadMode(GPIOB, GPIOB_PIN14, PAL_MODE_STM32_ALTERNATE_PUSHPULL);
   palSetPadMode(GPIOB, GPIOB_PIN15, PAL_MODE_STM32_ALTERNATE_PUSHPULL);
-  palSetPadMode(moduleGpioSpiChipSelect.gpio->port, moduleGpioSpiChipSelect.gpio->pad, PAL_MODE_OUTPUT_PUSHPULL);
+  palSetLineMode(moduleGpioSpiChipSelect.gpio->line, PAL_MODE_OUTPUT_PUSHPULL);
   apalGpioWrite(moduleGpioSpiChipSelect.gpio, APAL_GPIO_LOW);
 }
 
diff --git a/modules/NUCLEO-F103RB/module.h b/modules/NUCLEO-F103RB/module.h
index 07f6431..344337c 100644
--- a/modules/NUCLEO-F103RB/module.h
+++ b/modules/NUCLEO-F103RB/module.h
@@ -149,12 +149,12 @@ extern ROMCONST apalControlGpio_t moduleGpioUserButton;
 /**
  * @brief   Event flag to be call dwt_isr() interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_DW1000_IRQn      AOS_IOEVENT_FLAG(GPIOB_ARD_D6)
+#define MODULE_OS_IOEVENTFLAGS_DW1000_IRQn      AOS_IOEVENT_FLAG(PAL_PAD(LINE_ARD_D6))
 
 /**
  * @brief   Event flag to be set on a USER_BUTTON interrupt.
  */
-#define MODULE_OS_IOEVENTFLAGS_USERBUTTON       AOS_IOEVENT_FLAG(GPIOC_BUTTON)
+#define MODULE_OS_IOEVENTFLAGS_USERBUTTON       AOS_IOEVENT_FLAG(PAL_PAD(LINE_BUTTON))
 
 
 #if (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
@@ -164,21 +164,20 @@ extern ROMCONST apalControlGpio_t moduleGpioUserButton;
 extern ROMCONST char* moduleShellPrompt;
 #endif /* (AMIROOS_CFG_SHELL_ENABLE == true) || (AMIROOS_CFG_TESTS_ENABLE == true) */
 
-
 /**
  * @brief   Interrupt initialization macro.
  * @note    SSSP related interrupt signals are already initialized in 'aos_system.c'.
  */
 #define MODULE_INIT_INTERRUPTS() {                                            \
   /* user button */                                                           \
-  palSetPadCallback(moduleGpioUserButton.gpio->port, moduleGpioUserButton.gpio->pad, _intCallback, &moduleGpioUserButton.gpio->pad);  \
-  palEnablePadEvent(moduleGpioUserButton.gpio->port, moduleGpioUserButton.gpio->pad, APAL2CH_EDGE(moduleGpioUserButton.meta.edge));   \
+  palSetLineCallback(moduleGpioUserButton.gpio->line, aosSysGetStdIntCallback(), &moduleGpioUserButton.gpio->line); \
+  palEnableLineEvent(moduleGpioUserButton.gpio->line, APAL2CH_EDGE(moduleGpioUserButton.meta.edge));                \
   MODULE_INIT_INTERRUPTS_DW1000();                                            \
 }
 #if defined(AMIROLLD_CFG_DW1000)
   #define MODULE_INIT_INTERRUPTS_DW1000() {                                   \
-    palSetPadCallback(moduleGpioDw1000Irqn.gpio->port, moduleGpioDw1000Irqn.gpio->pad, _intCallback, &moduleGpioDw1000Irqn.gpio->pad);  \
-    palEnablePadEvent(moduleGpioDw1000Irqn.gpio->port, moduleGpioDw1000Irqn.gpio->pad, APAL2CH_EDGE(moduleGpioDw1000Irqn.meta.edge));   \
+    palSetLineCallback(moduleGpioDw1000Irqn.gpio->line, aosSysGetStdIntCallback(), &moduleGpioDw1000Irqn.gpio->line); \
+    palEnableLineEvent(moduleGpioDw1000Irqn.gpio->line, APAL2CH_EDGE(moduleGpioDw1000Irqn.meta.edge));                \
   }
 #else /* defined(AMIROLLD_CFG_DW1000) */
   #define MODULE_INIT_INTERRUPTS_DW1000() {                                   \
diff --git a/modules/NUCLEO-F401RE/alldconf.h b/modules/NUCLEO-F401RE/alldconf.h
index ae3a27e..2ba9287 100644
--- a/modules/NUCLEO-F401RE/alldconf.h
+++ b/modules/NUCLEO-F401RE/alldconf.h
@@ -33,7 +33,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
  */
 #define _AMIRO_LLD_CFG_
 #define AMIRO_LLD_CFG_VERSION_MAJOR             1
-#define AMIRO_LLD_CFG_VERSION_MINOR             0
+#define AMIRO_LLD_CFG_VERSION_MINOR             1
 
 /**
  * @brief   Width of the apalTime_t data type.
